const Mesa = require('vendor/Mesa.js');
const ShopifyGraphql = require('vendor/ShopifyGraphql.js');
const Shopify= require('vendor/Shopify.js');

module.exports = new class {

  script = (payload, context) => {
    let vars = context.steps;
    let query = `
      query orderCustomerJourney($id:ID!) {
        order(id: $id) {
          customerJourneySummary {
            momentsCount
            moments(first: 10, reverse: true) {
              nodes {
                occurredAt
                ... on CustomerVisit {
                  landingPage
                  source
                  utmParameters {
                    campaign
                    medium
                    source
                  }
                }
              }
            }
          }
        }
      }
    `;

    const r = ShopifyGraphql.send(query, {
      "id": "gid://shopify/Order/" + vars.shopify.id,
    });

    let moments = r.data.order.customerJourneySummary.moments.nodes;
    payload = {
      "first_visit": moments[moments.length - 1],
      "last_visit": moments[0],
    }

    Mesa.trigger.setTaskExternalData({
      "label": JSON.stringify(payload),
    })

    Mesa.output.next(payload);
  }
}
